// Generated by delombok at Wed Mar 13 20:31:42 UTC 2024
package gov.cms.fiss.pricers.hha.api.v2;

import gov.cms.fiss.pricers.common.api.serialization.StrictLocalDate;
import io.swagger.v3.oas.annotations.extensions.Extension;
import io.swagger.v3.oas.annotations.extensions.ExtensionProperty;
import io.swagger.v3.oas.annotations.media.Schema;
import java.time.LocalDate;
import javax.validation.constraints.Max;
import javax.validation.constraints.Min;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Pattern;

@Schema(description = "An input revenue line.", extensions = {@Extension(name = "cobol-declaration", properties = {@ExtensionProperty(name = "HHA-REVENUE-DATA", value = "<structure>")})})
public class RevenueLineData {
  @Schema(description = "The earliest line item date for the corresponding revenue code.", example = "2021-06-22", format = "yyyy-MM-dd", extensions = {@Extension(name = "cobol-declaration", properties = {@ExtensionProperty(name = "HHA-REVENUE-EARLIEST-DATE", value = "PIC 9(08)")})})
  @StrictLocalDate
  private LocalDate earliestLineItemDate;
  @NotNull
  @Pattern(regexp = "\\d{4}", message = "must be four digits")
  @Schema(description = "The associated revenue code.", example = "0841", extensions = {@Extension(name = "cobol-declaration", properties = {@ExtensionProperty(name = "HHA-REVENUE-CODE", value = "PIC X(04)")})})
  private String revenueCode;
  @Max(999)
  @Min(0)
  @Schema(description = "The quantity of covered visits corresponding to the revenue code.", example = "50", extensions = {@Extension(name = "cobol-declaration", properties = {@ExtensionProperty(name = "HHA-REVENUE-QTY-COV-VISITS", value = "PIC 9(03)")})})
  private int quantityOfCoveredVisits;
  @Max(99999)
  @Min(0)
  @Schema(description = "The sum of the units reported on all covered lines corresponding to the revenue code.", example = "32", extensions = {@Extension(name = "cobol-declaration", properties = {@ExtensionProperty(name = "HHA-REVENUE-QTY-OUTL-UNITS", value = "PIC 9(05)")})})
  private int quantityOfOutlierUnits;

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public LocalDate getEarliestLineItemDate() {
    return this.earliestLineItemDate;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public String getRevenueCode() {
    return this.revenueCode;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public int getQuantityOfCoveredVisits() {
    return this.quantityOfCoveredVisits;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public int getQuantityOfOutlierUnits() {
    return this.quantityOfOutlierUnits;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setEarliestLineItemDate(final LocalDate earliestLineItemDate) {
    this.earliestLineItemDate = earliestLineItemDate;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setRevenueCode(final String revenueCode) {
    this.revenueCode = revenueCode;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setQuantityOfCoveredVisits(final int quantityOfCoveredVisits) {
    this.quantityOfCoveredVisits = quantityOfCoveredVisits;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setQuantityOfOutlierUnits(final int quantityOfOutlierUnits) {
    this.quantityOfOutlierUnits = quantityOfOutlierUnits;
  }

  @java.lang.Override
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public boolean equals(final java.lang.Object o) {
    if (o == this) return true;
    if (!(o instanceof RevenueLineData)) return false;
    final RevenueLineData other = (RevenueLineData) o;
    if (!other.canEqual((java.lang.Object) this)) return false;
    if (this.getQuantityOfCoveredVisits() != other.getQuantityOfCoveredVisits()) return false;
    if (this.getQuantityOfOutlierUnits() != other.getQuantityOfOutlierUnits()) return false;
    final java.lang.Object this$earliestLineItemDate = this.getEarliestLineItemDate();
    final java.lang.Object other$earliestLineItemDate = other.getEarliestLineItemDate();
    if (this$earliestLineItemDate == null ? other$earliestLineItemDate != null : !this$earliestLineItemDate.equals(other$earliestLineItemDate)) return false;
    final java.lang.Object this$revenueCode = this.getRevenueCode();
    final java.lang.Object other$revenueCode = other.getRevenueCode();
    if (this$revenueCode == null ? other$revenueCode != null : !this$revenueCode.equals(other$revenueCode)) return false;
    return true;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  protected boolean canEqual(final java.lang.Object other) {
    return other instanceof RevenueLineData;
  }

  @java.lang.Override
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public int hashCode() {
    final int PRIME = 59;
    int result = 1;
    result = result * PRIME + this.getQuantityOfCoveredVisits();
    result = result * PRIME + this.getQuantityOfOutlierUnits();
    final java.lang.Object $earliestLineItemDate = this.getEarliestLineItemDate();
    result = result * PRIME + ($earliestLineItemDate == null ? 43 : $earliestLineItemDate.hashCode());
    final java.lang.Object $revenueCode = this.getRevenueCode();
    result = result * PRIME + ($revenueCode == null ? 43 : $revenueCode.hashCode());
    return result;
  }

  @java.lang.Override
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public java.lang.String toString() {
    return "RevenueLineData(earliestLineItemDate=" + this.getEarliestLineItemDate() + ", revenueCode=" + this.getRevenueCode() + ", quantityOfCoveredVisits=" + this.getQuantityOfCoveredVisits() + ", quantityOfOutlierUnits=" + this.getQuantityOfOutlierUnits() + ")";
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public RevenueLineData() {
  }
}
