// Generated by delombok at Wed Mar 13 20:31:42 UTC 2024
package gov.cms.fiss.pricers.hha.api.v2;

import gov.cms.fiss.pricers.common.api.annotations.FixedValue;
import gov.cms.fiss.pricers.common.api.serialization.BigDecimalScale;
import gov.cms.fiss.pricers.common.api.validation.ValidDecimalOutputWithTwoFractionDigits;
import gov.cms.fiss.pricers.common.util.BigDecimalUtils;
import io.swagger.v3.oas.annotations.extensions.Extension;
import io.swagger.v3.oas.annotations.extensions.ExtensionProperty;
import io.swagger.v3.oas.annotations.media.Schema;
import java.math.BigDecimal;
import javax.validation.constraints.DecimalMax;
import javax.validation.constraints.DecimalMin;
import javax.validation.constraints.Digits;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Pattern;

@Schema(description = "An output revenue line payment.", extensions = {@Extension(name = "cobol-declaration", properties = {@ExtensionProperty(name = "HHA-REVENUE-DATA", value = "<structure>")})})
public class RevenuePaymentData {
  @BigDecimalScale
  @Schema(description = "The add-on amount to be applied to the earliest line item date with the corresponding " + "revenue code.", example = "362.99", extensions = {@Extension(name = "cobol-declaration", properties = {@ExtensionProperty(name = "HHA-REVENUE-ADD-ON-VISIT-AMT", value = "PIC 9(09)V9(02)")})})
  @ValidDecimalOutputWithTwoFractionDigits
  private BigDecimal addOnVisitAmount = BigDecimalUtils.ZERO;
  @BigDecimalScale
  @Schema(description = "The dollar amount of the low-utilization payment adjustment (LUPA) payment or the " + "dollar amounts for the purposes of calculating an outlier payment.", example = "1200.99", extensions = {@Extension(name = "cobol-declaration", properties = {@ExtensionProperty(name = "HHA-REVENUE-COST", value = "PIC 9(09)V9(02)")})})
  @ValidDecimalOutputWithTwoFractionDigits
  private BigDecimal cost = BigDecimalUtils.ZERO;
  @BigDecimalScale
  @DecimalMin("0")
  @DecimalMax("999999999.99")
  @Digits(integer = 9, fraction = 2)
  @Schema(description = "The dollar rate used to calculate the low-utilization payment adjustment (LUPA) " + "payment or the dollar amount for the purposes of calculating an outlier payment.", example = "177.84", extensions = {@Extension(name = "cobol-declaration", properties = {@ExtensionProperty(name = "HHA-REVENUE-DOLL-RATE", value = "PIC 9(09)V9(02)")})})
  @FixedValue
  private BigDecimal dollarRate = BigDecimalUtils.ZERO;
  @NotNull
  @Pattern(regexp = "\\d{4}", message = "must be four digits")
  @Schema(description = "The associated revenue code.", example = "0841", extensions = {@Extension(name = "cobol-declaration", properties = {@ExtensionProperty(name = "HHA-REVENUE-CODE", value = "PIC X(04)")})})
  private String revenueCode;

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getAddOnVisitAmount() {
    return this.addOnVisitAmount;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getCost() {
    return this.cost;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getDollarRate() {
    return this.dollarRate;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public String getRevenueCode() {
    return this.revenueCode;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setAddOnVisitAmount(final BigDecimal addOnVisitAmount) {
    this.addOnVisitAmount = addOnVisitAmount;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setCost(final BigDecimal cost) {
    this.cost = cost;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setDollarRate(final BigDecimal dollarRate) {
    this.dollarRate = dollarRate;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setRevenueCode(final String revenueCode) {
    this.revenueCode = revenueCode;
  }

  @java.lang.Override
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public boolean equals(final java.lang.Object o) {
    if (o == this) return true;
    if (!(o instanceof RevenuePaymentData)) return false;
    final RevenuePaymentData other = (RevenuePaymentData) o;
    if (!other.canEqual((java.lang.Object) this)) return false;
    final java.lang.Object this$addOnVisitAmount = this.getAddOnVisitAmount();
    final java.lang.Object other$addOnVisitAmount = other.getAddOnVisitAmount();
    if (this$addOnVisitAmount == null ? other$addOnVisitAmount != null : !this$addOnVisitAmount.equals(other$addOnVisitAmount)) return false;
    final java.lang.Object this$cost = this.getCost();
    final java.lang.Object other$cost = other.getCost();
    if (this$cost == null ? other$cost != null : !this$cost.equals(other$cost)) return false;
    final java.lang.Object this$dollarRate = this.getDollarRate();
    final java.lang.Object other$dollarRate = other.getDollarRate();
    if (this$dollarRate == null ? other$dollarRate != null : !this$dollarRate.equals(other$dollarRate)) return false;
    final java.lang.Object this$revenueCode = this.getRevenueCode();
    final java.lang.Object other$revenueCode = other.getRevenueCode();
    if (this$revenueCode == null ? other$revenueCode != null : !this$revenueCode.equals(other$revenueCode)) return false;
    return true;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  protected boolean canEqual(final java.lang.Object other) {
    return other instanceof RevenuePaymentData;
  }

  @java.lang.Override
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public int hashCode() {
    final int PRIME = 59;
    int result = 1;
    final java.lang.Object $addOnVisitAmount = this.getAddOnVisitAmount();
    result = result * PRIME + ($addOnVisitAmount == null ? 43 : $addOnVisitAmount.hashCode());
    final java.lang.Object $cost = this.getCost();
    result = result * PRIME + ($cost == null ? 43 : $cost.hashCode());
    final java.lang.Object $dollarRate = this.getDollarRate();
    result = result * PRIME + ($dollarRate == null ? 43 : $dollarRate.hashCode());
    final java.lang.Object $revenueCode = this.getRevenueCode();
    result = result * PRIME + ($revenueCode == null ? 43 : $revenueCode.hashCode());
    return result;
  }

  @java.lang.Override
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public java.lang.String toString() {
    return "RevenuePaymentData(addOnVisitAmount=" + this.getAddOnVisitAmount() + ", cost=" + this.getCost() + ", dollarRate=" + this.getDollarRate() + ", revenueCode=" + this.getRevenueCode() + ")";
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public RevenuePaymentData() {
  }
}
