package gov.cms.fiss.pricers.hha.core.rules.validate_input;

import gov.cms.fiss.pricers.hha.core.HhaPricerContext;

public class ValidateExtraCountyCode extends ValidateCountyCode {
  @Override
  public boolean shouldExecute(HhaPricerContext calculationContext) {
    return calculationContext.getRuralCategory().isEmpty();
  }

  @Override
  public void calculate(HhaPricerContext calculationContext) {
    final String ruralCategory =
        calculationContext
            .getDataTables()
            .getExtraAddOnCategory(calculationContext.getInput().getProviderData().getCountyCode());
    if (ruralCategory != null) {
      calculationContext.setRuralCategory(ruralCategory);
    }
  }
}
